--- D:/nobackup/netgen-master/libsrc/meshing/_geomsearch.cpp	Sa Sep 22 12:50:59 2018
+++ D:/nobackup/netgen-master/libsrc/meshing/geomsearch.cpp	Fr Okt 12 21:15:23 2018
@@ -67,7 +67,7 @@ namespace netgen
     INDEX i,j,k;
     if (reset)
       {
-	const double hashelemsizefactor = 4;
+	double hashelemsizefactor = 4;
 	reset = 0;
 	/*
 	  minext=Point3d(MAXDOUBLE, MAXDOUBLE, MAXDOUBLE);
@@ -106,6 +106,13 @@ namespace netgen
 	size.i2 = int (boxext.Y()/midext.Y()/hashelemsizefactor+1);
 	size.i3 = int (boxext.Z()/midext.Z()/hashelemsizefactor+1);
 	// PrintMessage (5, "hashsizes = ", size.i1, ", ", size.i2, ", ", size.i3);
+	if (size_t(size.i1)*size.i2*size.i3 > size_t(512*512*512))
+	  {
+	    hashelemsizefactor *= pow(size_t(size.i1)*size.i2*size.i3 / double(256*512*512), 1./3);
+	    size.i1 = int (boxext.X()/midext.X()/hashelemsizefactor+1);
+	    size.i2 = int (boxext.Y()/midext.Y()/hashelemsizefactor+1);
+	    size.i3 = int (boxext.Z()/midext.Z()/hashelemsizefactor+1);
+	  }
       
 	elemsize.X()=boxext.X()/size.i1;
 	elemsize.Y()=boxext.Y()/size.i2;
